unit Setup;

//////////////////////////////////////////////////////////
///    Fiche des paramtres  donner au tlescope   //////
///              lors du dmarrage                  //////
///////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, COMM, IniFiles,Spin, HiresTim;

type
  TSetupTelescope = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    CheckBox_DIR_AD: TCheckBox;
    GroupBox2: TGroupBox;
    SpinEdit_A_Guidage_AD: TSpinEdit;
    SpinEdit_A_Lent_AD: TSpinEdit;
    SpinEdit_A_Rapide_AD: TSpinEdit;
    OpenDialog1: TOpenDialog;
    Panel12: TPanel;
    ProgressBarProgrammer: TProgressBar;
    Panel13: TPanel;
    ButtonOurvrir: TButton;
    Panel14: TPanel;
    ButtonVersion: TButton;
    Panel15: TPanel;
    ButtonProgrammer: TButton;
    RadioGroupAxe: TRadioGroup;
    Panel16: TPanel;
    ButtonCancel: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    CheckBoxProgAuto: TCheckBox;
    TabSheet4: TTabSheet;
    GroupBox8: TGroupBox;
    EditResolAlpha: TEdit;
    Panel17: TPanel;
    ButtonEvaluer: TButton;
    Panel18: TPanel;
    ButtonUtiliser: TButton;
    GroupBox9: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    EditResolDelta: TEdit;
    LabelResolAlpha: TLabel;
    LabelResolDelta: TLabel;
    LabelVitSid: TLabel;
    LabelVitGuidage: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label2VitCorrAlpha: TLabel;
    Label2VitCorrDelta: TLabel;
    LabelVitPointLentAlpha: TLabel;
    LabelVitPointLentDelta: TLabel;
    LabelVitPointRapideAlpha: TLabel;
    LabelVitPointRapideDelta: TLabel;
    Panel19: TPanel;
    ButtonActuel: TButton;
    Timer1: TTimer;
    InfoProgramme: TPanel;
    Panel7: TPanel;
    Button_Charger: TButton;
    Panel6: TPanel;
    Button_Sauver: TButton;
    Panel5: TPanel;
    Button_Ecrire: TButton;
    Panel4: TPanel;
    Button_Lire: TButton;
    GroupBox1: TGroupBox;
    Edit_V_Guidage_AD: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    Edit_V_Corr_P_AD: TEdit;
    Panel25: TPanel;
    Edit_V_Corr_M_AD: TEdit;
    Panel26: TPanel;
    Edit_V_Point_L_AD: TEdit;
    Panel27: TPanel;
    Edit_V_Point_R_AD: TEdit;
    Panel28: TPanel;
    Panel3: TPanel;
    Edit_Resol_AD: TEdit;
    Panel29: TPanel;
    CheckBox_PEC: TCheckBox;
    GroupBox4: TGroupBox;
    Panel30: TPanel;
    Panel31: TPanel;
    Panel32: TPanel;
    Panel33: TPanel;
    Panel34: TPanel;
    GroupBox10: TGroupBox;
    Panel35: TPanel;
    Panel36: TPanel;
    Edit_V_Guidage_DEC: TEdit;
    Edit_V_Corr_P_DEC: TEdit;
    Edit_V_Corr_M_DEC: TEdit;
    Edit_V_Point_L_DEC: TEdit;
    Edit_V_Point_R_DEC: TEdit;
    Edit_Resol_DEC: TEdit;
    CheckBox_DIR_DEC: TCheckBox;
    Panel37: TPanel;
    Panel10: TPanel;
    Button1: TButton;
    Panel11: TPanel;
    Button2: TButton;
    GroupBox3: TGroupBox;
    ComboBoxNumCOM: TComboBox;
    SpinEdit_A_Guidage_DEC: TSpinEdit;
    SpinEdit_A_Lent_DEC: TSpinEdit;
    SpinEdit_A_Rapide_DEC: TSpinEdit;
    Panel8: TPanel;
    Panel9: TPanel;
    ComboBox_Accel_AD: TComboBox;
    ComboBox_Accel_DEC: TComboBox;
    AfficheNomFichier: TPanel;
    CheckBox_Raq_Can: TCheckBox;
    HiResTimer1: THiResTimer;
    procedure Button_LireClick(Sender: TObject);
    procedure Button_EcrireClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonVersionClick(Sender: TObject);
    procedure ButtonOurvrirClick(Sender: TObject);
    procedure ButtonProgrammerClick(Sender: TObject);
    function Communication(Instr: byte; VysBuff : string) : boolean;
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonEvaluerClick(Sender: TObject);
    procedure ButtonActuelClick(Sender: TObject);
    procedure ButtonUtiliserClick(Sender: TObject);
    procedure FOCUS_M(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FOCUS_P(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FOCUS_STOP(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button_SauverClick(Sender: TObject);
    procedure Button_ChargerClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetupTelescope: TSetupTelescope;
   //Variables qui serviront  copier et lire des donnes dans le buffer du port COM
   NumberOfBytesWrite,NumberOfBytesRead:LongWord;
   BufWrite:array[0..15] of char;
   BufRead:array[0..33] of char;
   Err_COM,ProgramCancel:Boolean;
   codeuralpha,codeurdelta: longint;
   vit_a_guide,vit_d_guide,vit_a_cor_p,vit_a_cor_m,vit_d_cor_p,vit_d_cor_m,
   vit_a_rap,vit_a_lent,vit_d_rap,vit_d_lent : double;

const                   // Protocole de programmation BootLoader
  READ = $E0;
  RACK = $E1;

  WRITE = $E3;
  WOK = $E4;
  WBAD = $E5;

  DATA_OK = $E7;
  DAT_BAD = $E8;

  IDENT = $F0;
  IDACK = $EB;

  DONE = $ED;

implementation

{$R *.DFM}

procedure TSetupTelescope.Button_LireClick(Sender: TObject);

var
    astring,receivestring: ShortString;
    anum: longword;

begin
 //Connaitre le port COM utilis
 NumCOM:=StrToInt(ComboBoxNumCOM.Text);
 //Vrification des ports COM
 while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if Err_COM then
     begin
     FlushFileBuffers(hCom);
     if deviceready(0) = 1 then
      begin
       astring := 'K'+chr(0)+chr(0)+chr(0)+chr(0);
       receivestring := sendcommand(astring,48,0);
       if receivestring <> '' then
        begin
         Button_Ecrire.Enabled:=false;
         Button_Sauver.Enabled:=false;
         Button_Charger.Enabled:=false;
         Button1.Enabled:=false;
         Button2.Enabled:=false;

         if (ord(receivestring[2]) <> 0) or (ord(receivestring[1]) <> 0) then
          Edit_V_Guidage_AD.text := floattostrf(625000/(ord(receivestring[3])/10+ord(receivestring[2])*256+ord(receivestring[1])),ffFixed,6,6)
         else
          Edit_V_Guidage_AD.text := '0';

         if (ord(receivestring[5]) <> 0) or (ord(receivestring[4]) <> 0) then
          Edit_V_Corr_P_AD.text := floattostrf(625000/(ord(receivestring[5])*256+ord(receivestring[4])),ffFixed,6,3)
         else
          Edit_V_Corr_P_AD.text := '0';

         if (ord(receivestring[7]) <> 0) or (ord(receivestring[6]) <> 0) then
          Edit_V_Corr_M_AD.text := floattostrf(625000/(ord(receivestring[7])*256+ord(receivestring[6])),ffFixed,6,3)
         else
          Edit_V_Corr_M_AD.text := '0';

         if (ord(receivestring[9]) <> 0) or (ord(receivestring[8]) <> 0) then
          Edit_V_Point_L_AD.text := floattostrf((625000/(ord(receivestring[9])*256+ord(receivestring[8]))*8),ffFixed,6,1)
         else
          Edit_V_Point_L_AD.text := '0';

         if (ord(receivestring[11]) <> 0) or (ord(receivestring[10]) <> 0) then
          Edit_V_Point_R_AD.text := floattostrf((625000/(ord(receivestring[11])*256+ord(receivestring[10]))*32),ffFixed,6,1)
         else
          Edit_V_Point_R_AD.text := '0';

         ComboBox_Accel_AD.ItemIndex := ord(receivestring[12]);
         if ord(receivestring[13]) = 1 then CheckBox_DIR_AD.Checked := true
          else CheckBox_DIR_AD.Checked := false;
         SpinEdit_A_Guidage_AD.value := 25*(ord(receivestring[25])+1);
         SpinEdit_A_Lent_AD.value := 25*(ord(receivestring[26])+1);
         SpinEdit_A_Rapide_AD.value := 25*(ord(receivestring[27])+1);
         anum := 25600 * (ord(receivestring[29])*256 + ord(receivestring[30]));
         Edit_Resol_AD.text := IntToStr(anum);
         if ord(receivestring[32]) = 1 then CheckBox_Raq_Can.Checked := true
          else CheckBox_Raq_Can.Checked := false;
         if ord(receivestring[48]) = 1 then CheckBox_PEC.Checked := true
          else CheckBox_PEC.Checked := false;
         Button_Ecrire.Enabled:=true;
         Button_Sauver.Enabled:=true;
         Button_Charger.Enabled:=true;
         Button1.Enabled:=true;
         Button2.Enabled:=true;

        end
        else
         ShowMessage('Erreur deviceready du device '+inttostr(0)+' '+inttostr(NumCOM)+'!');
      end;

     FlushFileBuffers(hCom);
     if deviceready(1) = 1 then
      begin
       astring := 'K'+chr(0)+chr(0)+chr(0)+chr(0);
       receivestring := sendcommand(astring,48,1);
       if receivestring <> '' then
        begin
         Button_Ecrire.Enabled:=false;
         Button_Sauver.Enabled:=false;
         Button_Charger.Enabled:=false;
         Button1.Enabled:=false;
         Button2.Enabled:=false;

         if (ord(receivestring[2]) <> 0) or (ord(receivestring[1]) <> 0) then
          Edit_V_Guidage_DEC.text := floattostrf(625000/(ord(receivestring[2])*256+ord(receivestring[1])),ffFixed,6,6)
         else
          Edit_V_Guidage_DEC.text := '0';

         if (ord(receivestring[5]) <> 0) or (ord(receivestring[4]) <> 0) then
          Edit_V_Corr_P_DEC.text := floattostrf(625000/(ord(receivestring[5])*256+ord(receivestring[4])),ffFixed,6,3)
         else
          Edit_V_Corr_P_DEC.text := '0';

         if (ord(receivestring[7]) <> 0) or (ord(receivestring[6]) <> 0) then
          Edit_V_Corr_M_DEC.text := floattostrf(625000/(ord(receivestring[7])*256+ord(receivestring[6])),ffFixed,6,3)
         else
          Edit_V_Corr_M_DEC.text := '0';

         if (ord(receivestring[9]) <> 0) or (ord(receivestring[8]) <> 0) then
          Edit_V_Point_L_DEC.text := floattostrf((625000/(ord(receivestring[9])*256+ord(receivestring[8]))*8),ffFixed,6,1)
         else
          Edit_V_Point_L_DEC.text := '0';

         if (ord(receivestring[11]) <> 0) or (ord(receivestring[10]) <> 0) then
          Edit_V_Point_R_DEC.text := floattostrf((625000/(ord(receivestring[11])*256+ord(receivestring[10]))*32),ffFixed,6,1)
         else
          Edit_V_Point_R_DEC.text := '0';

         ComboBox_Accel_DEC.ItemIndex := ord(receivestring[12]);
         if ord(receivestring[13]) = 1 then CheckBox_DIR_DEC.Checked := true
          else CheckBox_DIR_DEC.Checked := false;
         SpinEdit_A_Guidage_DEC.value := 25*(ord(receivestring[25])+1);
         SpinEdit_A_Lent_DEC.value := 25*(ord(receivestring[26])+1);
         SpinEdit_A_Rapide_DEC.value := 25*(ord(receivestring[27])+1);
         anum := 25600 * (ord(receivestring[29])*256 + ord(receivestring[30]));
         Edit_Resol_DEC.text := IntToStr(anum);

         Button_Ecrire.Enabled:=true;
         Button_Sauver.Enabled:=true;
         Button_Charger.Enabled:=true;
         Button1.Enabled:=true;
         Button2.Enabled:=true;

        end
        else
         ShowMessage('Erreur deviceready du device '+inttostr(1)+' '+inttostr(NumCOM)+'!');
       end;

      FlushFileBuffers(hCom);
     end;
     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !

   finally
     CloseHandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

procedure TSetupTelescope.Button_EcrireClick(Sender: TObject);
var
    astring: ShortString;
    anum: integer;
    MSB,LSB: byte;
    number: longword;

function CalcValue(bstring: ShortString): integer;

var temp :integer;

begin
 if strtofloat(bstring) > 0 then
  begin
   temp := round(int(625000 / strtofloat(bstring)));
   if temp > 65535 then CalcValue := 65535 else CalcValue := temp;
  end
 else
  CalcValue := 0;
end;

begin
 //Connaitre le port COM utilis
 NumCOM:=StrToInt(ComboBoxNumCOM.Text);
 //Vrification des ports COM
 while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if (Err_COM) and (deviceready(0) = 1) and (deviceready(1) = 1) then
     begin
      Button_Ecrire.Enabled:=false;
      Button_Lire.Enabled:=false;
      Button_Sauver.Enabled:=false;
      Button_Charger.Enabled:=false;
      Button1.Enabled:=false;
      Button2.Enabled:=false;

      FlushFileBuffers(hCom);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       anum := CalcValue(Edit_V_Guidage_AD.text);
       astring:='L'+chr(0)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       if strtofloat(Edit_V_Guidage_AD.text)> 0 then
        anum := round(10*frac(625000 / strtofloat(Edit_V_Guidage_AD.text)))
       else
        anum := 0;
       astring:='L'+chr(2)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       anum := CalcValue(Edit_V_Corr_P_AD.text);
       astring:='L'+chr(3)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       anum := CalcValue(Edit_V_Corr_M_AD.text);
       astring:='L'+chr(5)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       anum := 8 * CalcValue(Edit_V_Point_L_AD.text);
       astring:='L'+chr(7)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       anum := 32 * CalcValue(Edit_V_Point_R_AD.text);
       astring:='L'+chr(9)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       anum := ComboBox_Accel_AD.ItemIndex;
       if anum = -1 then anum := 0;
       astring:='L'+chr(11)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       if CheckBox_DIR_AD.Checked = true then
        anum := 1
       else
        anum := 0;
       astring:='L'+chr(12)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(24)+chr((SpinEdit_A_Guidage_AD.value div 25)-1)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(25)+chr((SpinEdit_A_Lent_AD.value div 25)-1)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(26)+chr((SpinEdit_A_Rapide_AD.value div 25)-1)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       try
        number := StrToInt(Edit_Resol_AD.text);
       except
        number := 0;
       end;
       number := number div 25600;
       MSB:= (abs(number) SHR 8) and $FF;
       LSB:= abs(number) and $FF;
       astring:='L'+chr(28)+chr(MSB)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(29)+chr(LSB)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       if CheckBox_Raq_Can.Checked = true then
        anum := 1
       else
        anum := 0;
       astring:='L'+chr(31)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;
       if CheckBox_PEC.Checked = true then
        anum := 1
       else
        anum := 0;
       astring:='L'+chr(47)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,0);
      while deviceready(0) <> 1 do Application.ProcessMessages;

//******************************************************************************
      FlushFileBuffers(hCom);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       anum := CalcValue(Edit_V_Guidage_DEC.text);
       astring:='L'+chr(0)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       anum := CalcValue(Edit_V_Corr_P_DEC.text);
       astring:='L'+chr(3)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1  do Application.ProcessMessages;
       anum := CalcValue(Edit_V_Corr_M_DEC.text);
       astring:='L'+chr(5)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       anum := 8 * CalcValue(Edit_V_Point_L_DEC.text);
       astring:='L'+chr(7)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do  Application.ProcessMessages;
       anum := 32 * CalcValue(Edit_V_Point_R_DEC.text);
       astring:='L'+chr(9)+chr(anum)+chr(anum shr 8)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       anum := ComboBox_Accel_DEC.ItemIndex;
       if anum = -1 then anum := 0;
       astring:='L'+chr(11)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       if CheckBox_DIR_DEC.Checked = true then
        anum := 1
       else
        anum := 0;
       astring:='L'+chr(12)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(24)+chr((SpinEdit_A_Guidage_DEC.value div 25)-1)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(25)+chr((SpinEdit_A_Lent_DEC.value div 25)-1)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(26)+chr((SpinEdit_A_Rapide_DEC.value div 25)-1)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       try
        number := StrToInt(Edit_Resol_DEC.text);
       except
        number := 0;
       end;
       number := number div 25600;
       MSB:= (abs(number) SHR 8) and $FF;
       LSB:= abs(number) and $FF;
       astring:='L'+chr(28)+chr(MSB)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       astring:='L'+chr(29)+chr(LSB)+chr(0)+chr(0);
       sendcommand(astring,0,1);
      while deviceready(1) <> 1 do Application.ProcessMessages;
       if CheckBox_Raq_Can.Checked = true then
        anum := 1
       else
        anum := 0;
       astring:='L'+chr(31)+chr(anum)+chr(0)+chr(0);
       sendcommand(astring,0,1);
     end
     else
       ShowMessage('Erreur deviceready de MCMT '+' '+inttostr(NumCOM)+'!');

//******************************************************************************

     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !
     Button_Ecrire.Enabled:=true;
     Button_Lire.Enabled:=true;
     Button_Sauver.Enabled:=true;
     Button_Charger.Enabled:=true;
     Button1.Enabled:=true;
     Button2.Enabled:=true;

   finally
     CloseHandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

procedure TSetupTelescope.Timer1Timer(Sender: TObject);
begin
 Timer1.Enabled := false;
end;

procedure TSetupTelescope.ButtonVersionClick(Sender: TObject);
var
    astring,receivestring: ShortString;
    device: integer;

begin
 AfficheNomFichier.Caption := '';
 device := RadioGroupAxe.ItemIndex;
 //Connaitre le port COM utilis
 NumCOM:=StrToInt(ComboBoxNumCOM.Text);
 //Vrification des ports COM
 while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if Err_COM then
     begin
      FlushFileBuffers(hCom);
      if deviceready(device) = 1 then
      begin
       astring := 'V'+chr(0)+chr(0)+chr(0)+chr(0);
       receivestring := sendcommand(astring,80,device);
       if receivestring <> '' then
         AfficheNomFichier.Caption := receivestring
       else
         AfficheNomFichier.Caption := 'Version introuvable';
      end
      else
       ShowMessage('Erreur deviceready du device '+inttostr(device)+' '+inttostr(NumCOM)+'!');
     end;
     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !

   finally
     CloseHandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

procedure TSetupTelescope.ButtonOurvrirClick(Sender: TObject);
var DeviceIni : TIniFile;

begin
 DeviceIni := TIniFile.Create('mcmtii.ini');
 with DeviceIni do
 begin
  OpenDialog1.FileName := ReadString('Configuration','FirmwareFile','');
 end;
 DeviceIni.free;

 if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    AfficheNomFichier.caption := OpenDialog1.FileName;   { File selected in dialog box }
    ButtonProgrammer.enabled := true;
  end;
end;

procedure TSetupTelescope.ButtonProgrammerClick(Sender: TObject);

var
    NbOfBytesWrite,NbOfBytesRead:LongWord;
    RecBuff : array [0..79] of byte;
    SendBuff : array [0..79] of byte;
    fic_prog : textfile;
    astring,receivestring: shortstring;
    device: integer;
    OkProg,autostart: Boolean;
    Data: string;
    ComOK, EndOfRecord: boolean;
    NumberOfLines, LineNumber : integer;

begin
 InfoProgramme.caption:= '';
 ButtonProgrammer.Enabled:=false;
 ButtonOurvrir.Enabled:=false;
 ButtonVersion.Enabled:=false;
 Button1.Enabled:=false;
 Button2.Enabled:=false;
 Button_Lire.Enabled:=false;
 Button_Ecrire.Enabled:=false;
 Button_Sauver.Enabled:=false;
 Button_Charger.Enabled:=false;
 OkProg := true;
 ProgramCancel := false;
 ButtonCancel.enabled := true;
 ProgressBarProgrammer.position:=0;
 assignfile(fic_prog,OpenDialog1.FileName);

 if OkProg then
 begin
  MAJ := true;
  //Connaitre le port COM utilis
  NumCOM:=StrToInt(ComboBoxNumCOM.Text);

  //Vrification des ports COM
  while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
  try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if Err_COM then
     begin
      FlushFileBuffers(hCom);

      device := RadioGroupAxe.ItemIndex;

      if not CheckBoxProgAuto.checked then
       begin
        ShowMessage('Mettez le module sous tension!');
       end
      else
       begin
        FlushFileBuffers(hCom);
        if deviceready(device) = 1 then
        begin
         astring := 'M'+chr(0)+chr(0)+chr(0)+chr(0);
         receivestring := sendcommand(astring,0,device);
        end;
       end;

      AutoStart := false;
      RecBuff[0]:=0;
      while (not AutoStart) and (Not ProgramCancel) do
       begin
        Application.ProcessMessages;
        SendBuff[0]:=IDENT + device;
        WriteFile(hCom,SendBuff,1,NbOfBytesWrite,nil);
        ReadFile(hCom, RecBuff, 1, NbOfBytesRead, nil);   //receive IDACK
        if (NbOfBytesRead = 1) and (RecBuff[0] = IDACK) then
          AutoStart := true;
       end;

      ComOK := false;
      if AutoStart and (not ProgramCancel) then
      begin
        ComOK := true;
        InfoProgramme.caption:= 'Programmation en cour !';
      end;

      if ComOK then
      begin
        NumberOfLines := 0;
        Reset(fic_prog);
        while not EOF(fic_prog) do
        begin
          Readln(fic_prog, Data);               //Number of lines
          NumberOfLines := NumberOfLines +1;
        end;

        EndOfRecord := false;
        LineNumber := 0;
        Reset(fic_prog);
        while not (EOF(fic_prog)) and (ComOK) and (not EndOfRecord) do
        begin
          if ProgramCancel then
            ComOK := false;
          Readln(fic_prog, Data);                 //Read one line
          LineNumber := LineNumber + 1;
          ProgressBarProgrammer.position := (LineNumber*100) div NumberOfLines;
          if (Length(Data) <> 0) then
          begin
            if (Data[1] = ':') then
            begin
              if ((Data [8] = '0') and (Data [9] = '0')) then
              begin                             // if Data Record then send
                if not Communication (WRITE, Data) then ComOK := false;
              end
              else
              begin
                if ((Data [8] = '0') and (Data [9] = '1')) then
                begin
                  EndOfRecord := true;          // End of File Record
                end;
              end;
            end
            else
            begin
              ComOK := false;
              Application.MessageBox(PChar('Hex file error !'+#10+#13+'Line number '+IntToStr(LineNumber)+' does not begin with the colon !'), 'Information' ,MB_OK);
            end;
          end
          else
          begin
            ComOK := false;
            Application.MessageBox(PChar('Hex file error !'+#10+#13+'Empty line number '+IntToStr(LineNumber)+' !'), 'Information', MB_OK);
          end;
        end;

        if ComOK then
        begin
          if Communication (DONE, Data) then
          begin
            ProgressBarProgrammer.position := 100;
            InfoProgramme.caption := 'Programmation complte avec succs !';
            Beep();
            Timer1.Enabled := true;
            while Timer1.Enabled do
            begin
              Application.ProcessMessages;
            end;
          end
          else
          begin
            ComOK := false;
          end;
        end;

        if ProgramCancel then
        begin
          InfoProgramme.caption := 'Programmation interrompue !';
        end
        else
        begin
          if not ComOK then
          begin
            Application.MessageBox('Erreur de transfert !', 'Information', MB_OK);
          end;
        end;
        EscapeCommFunction(hCom, CLRDTR);        // trigger pin = 1
        CloseFile(fic_prog);
      end
      else
      begin
        if not ProgramCancel then
        begin
          Application.MessageBox('Timeout of communication, '+#13+#10+'please check port and ready of PIC for download !', 'Information', MB_OK);
        end
        else
          InfoProgramme.caption := 'Programmation interrompue !';
      end;
    end;

    ButtonCancel.enabled := false;
    ButtonProgrammer.Enabled:=true;
    Button1.Enabled:=true;
    Button2.Enabled:=true;
    ButtonOurvrir.Enabled:=true;
    ButtonVersion.Enabled:=true;
    Button_Lire.Enabled:=true;
    Button_Ecrire.Enabled:=true;
    Button_Sauver.Enabled:=true;
    Button_Charger.Enabled:=true;

     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !

   finally
     CloseHandle(hCom);
   end;
  finally
   AccesCom(NumCOM);
   MAJ := false;
  end;
 end
 else
  ShowMessage('Impossible de lancer la mise  jour du device '+inttostr(device)+' '+inttostr(NumCOM)+'!');

end;

function TSetupTelescope.Communication(Instr: byte; VysBuff : string) : boolean;
var
  Sended : dword;
  Received : dword;
  CheckSum : byte;
  NumberOfData, N, Pointer : byte;
  RecBuff : array [0..40] of byte;
  SendBuff : array [0..40] of byte;
  SendLength : byte;
  RecLength : byte;
  Code, I, J : integer;
  fSuccess : boolean;
  Address : word;
begin
  fSuccess := True;
  Communication := True;

  SendBuff[0] := Instr;
  SendLength := 1;
  RecLength := 1;

  if Instr = WRITE then
  begin
    Val('$'+VysBuff[4]+VysBuff[5], I, Code);
    Val('$'+VysBuff[6]+VysBuff[7], J, Code);
    Address := ((I*256) + J) div 2;
    if (Address >= $2000) and (Address < $2100) then
    begin                                         //don't send address from 0x2000 to 0x20FF
      Communication := True;
      exit;
    end;

    SendBuff[1] := Address div 256;               //high byte of address
    SendBuff[2] := Address - (SendBuff[1]*256);   //low byte of address
    Val('$'+VysBuff[2]+VysBuff[3], I, Code);
    NumberOfData := I;
    SendBuff[3] := NumberOfData;                  //number of data
    CheckSum := 0;
    for N := 1 to NumberOfData div 2 do
    begin
      Pointer := (N-1) * 4;
      Val('$'+VysBuff [12+Pointer]+VysBuff[13+Pointer], I, Code);
      SendBuff [5 + ((N-1)*2)] := I;             //high byte of instruction
      CheckSum := CheckSum + I;
      Val('$'+VysBuff [10+Pointer]+VysBuff[11+Pointer], I, Code);
      SendBuff [6 + ((N-1)*2)] := I;             //low byte of instruction
      CheckSum := CheckSum + I;
    end;
    SendBuff[4] := CheckSum;                     //checksum
    SendLength := 5 + NumberOfData;
    RecLength := 2;                              //wait for 2 bytes
  end;

  Application.ProcessMessages;
  PurgeComm(hCom,PURGE_TXABORT+PURGE_RXABORT+PURGE_TXCLEAR+PURGE_RXCLEAR);
  WriteFile(hCom, SendBuff, SendLength, Sended, nil);  //send
  ReadFile(hCom, RecBuff, RecLength, Received, nil);   //receive
  if(Received > 0) then
    case Instr of
      IDENT:  if RecBuff[0] = IDACK then Communication := True
              else Communication := False;
      WRITE:  if ((RecBuff[0] = DATA_OK) and (RecBuff[1] = WOK)) then Communication := True
              else Communication := False;
      DONE:   if RecBuff[0] = WOK then Communication := True
              else Communication := False;
    end
  else fSuccess := False;

  PurgeComm(hCom,PURGE_TXABORT+PURGE_RXABORT+PURGE_TXCLEAR+PURGE_RXCLEAR);
  if(not fSuccess) then begin
    Application.MessageBox('Timeout of communication !', 'Information', MB_OK);
    Communication := false;
  end;
end;

procedure TSetupTelescope.ButtonCancelClick(Sender: TObject);
begin
 ProgramCancel := true;
end;

procedure TSetupTelescope.Button_SauverClick(Sender: TObject);

var DeviceIni : TIniFile;

begin
 if SaveDialog1.Execute then          { Display Save dialog box }
  begin
      DeviceIni := TIniFile.Create(SaveDialog1.FileName);
      with DeviceIni do
        begin
         NumCom := StrToInt(ComboBoxNumCOM.text);
         WriteInteger('Configuration','Port',NumCOM);
         WriteBool('Parameters', 'DIR_AD', CheckBox_DIR_AD.Checked);
         WriteBool('Parameters', 'DIR_DEC', CheckBox_DIR_DEC.checked);
         WriteBool('Parameters', 'PEC_AD', CheckBox_PEC.checked);
         WriteBool('Parameters', 'Raq_Can', CheckBox_Raq_Can.checked);
         WriteInteger('Parameters', 'Resol_AD', strtoint(Edit_Resol_AD.text));
         WriteInteger('Parameters', 'Resol_DEC', strtoint(Edit_Resol_DEC.text));
         WriteString('Parameters', 'ReducAlpha', EditResolAlpha.text);
         WriteString('Parameters', 'ReducDelta', EditResolDelta.text);
         WriteString('Parameters', 'V_Guidage_AD', Edit_V_Guidage_AD.text);
         WriteString('Parameters', 'V_Guidage_DEC', Edit_V_Guidage_DEC.text);
         WriteString('Parameters', 'V_Corr_P_AD', Edit_V_Corr_P_AD.text);
         WriteString('Parameters', 'V_Corr_P_DEC', Edit_V_Corr_P_DEC.text);
         WriteString('Parameters', 'V_Corr_M_AD', Edit_V_Corr_M_AD.text);
         WriteString('Parameters', 'V_Corr_M_DEC', Edit_V_Corr_M_DEC.text);
         WriteString('Parameters', 'V_Point_L_AD', Edit_V_Point_L_AD.text);
         WriteString('Parameters', 'V_Point_L_DEC', Edit_V_Point_L_DEC.text);
         WriteString('Parameters', 'V_Point_R_AD', Edit_V_Point_R_AD.text);
         WriteString('Parameters', 'V_Point_R_DEC', Edit_V_Point_R_DEC.text);
         WriteString('Parameters', 'Accel_AD', inttostr(ComboBox_Accel_AD.ItemIndex));
         WriteString('Parameters', 'Accel_DEC', inttostr(ComboBox_Accel_DEC.ItemIndex));
         WriteInteger('Parameters', 'A_Guidage_AD', SpinEdit_A_Guidage_AD.value);
         WriteInteger('Parameters', 'A_Guidage_DEC', SpinEdit_A_Guidage_DEC.value);
         WriteInteger('Parameters', 'A_Lent_AD', SpinEdit_A_Lent_AD.value);
         WriteInteger('Parameters', 'A_Lent_DEC', SpinEdit_A_Lent_DEC.value);
         WriteInteger('Parameters', 'A_Rapide_AD', SpinEdit_A_Rapide_AD.value);
         WriteInteger('Parameters', 'A_Rapide_DEC', SpinEdit_A_Rapide_DEC.value);
        end;
     DeviceIni.free;
  end;
end;

procedure TSetupTelescope.Button_ChargerClick(Sender: TObject);

var DeviceIni : TIniFile;

begin
 if OpenDialog2.Execute then          { Display Open dialog box }
  begin
   DeviceIni := TIniFile.Create(OpenDialog2.FileName);
   with DeviceIni do
   begin
    NumCOM:=ReadInteger('Configuration','Port',1);
    CheckBox_DIR_AD.Checked :=ReadBool('Parameters', 'DIR_AD', False);
    CheckBox_DIR_DEC.checked:=ReadBool('Parameters', 'DIR_DEC', False);
    CheckBox_PEC.checked:=ReadBool('Parameters', 'PEC_AD', False);
    CheckBox_Raq_Can.checked:=ReadBool('Parameters', 'Raq_Can', False);
    Edit_Resol_AD.text:=inttostr(ReadInteger('Parameters', 'Resol_AD', 4608000));
    Edit_Resol_DEC.text:=inttostr(ReadInteger('Parameters', 'Resol_DEC', 4608000));
    EditResolAlpha.text := ReadString('Parameters', 'ReducAlpha', '360');
    EditResolDelta.text := ReadString('Parameters', 'ReducDelta', '360');
    Edit_V_Guidage_AD.text := ReadString('Parameters', 'V_Guidage_AD', '1');
    Edit_V_Guidage_DEC.text := ReadString('Parameters', 'V_Guidage_DEC', '1');
    Edit_V_Corr_P_AD.text := ReadString('Parameters', 'V_Corr_P_AD', '1');
    Edit_V_Corr_P_DEC.text := ReadString('Parameters', 'V_Corr_P_DEC', '1');
    Edit_V_Corr_M_AD.text := ReadString('Parameters', 'V_Corr_M_AD', '1');
    Edit_V_Corr_M_DEC.text := ReadString('Parameters', 'V_Corr_M_DEC', '1');
    Edit_V_Point_L_AD.text := ReadString('Parameters', 'V_Point_L_AD', '1');
    Edit_V_Point_L_DEC.text := ReadString('Parameters', 'V_Point_L_DEC', '1');
    Edit_V_Point_R_AD.text := ReadString('Parameters', 'V_Point_R_AD', '1');
    Edit_V_Point_R_DEC.text := ReadString('Parameters', 'V_Point_R_DEC', '1');
    ComboBox_Accel_AD.ItemIndex := strtoint(ReadString('Parameters', 'Accel_AD', '0'));
    ComboBox_Accel_DEC.ItemIndex := strtoint(ReadString('Parameters', 'Accel_DEC', '0'));
    SpinEdit_A_Guidage_AD.value := ReadInteger('Parameters', 'A_Guidage_AD', 25);
    SpinEdit_A_Guidage_DEC.value := ReadInteger('Parameters', 'A_Guidage_DEC', 25);
    SpinEdit_A_Lent_AD.value := ReadInteger('Parameters', 'A_Lent_AD', 25);
    SpinEdit_A_Lent_DEC.value := ReadInteger('Parameters', 'A_Lent_DEC', 25);
    SpinEdit_A_Rapide_AD.value := ReadInteger('Parameters', 'A_Rapide_AD', 25);
    SpinEdit_A_Rapide_DEC.value := ReadInteger('Parameters', 'A_Rapide_DEC', 25);
   end;
   DeviceIni.free;
  end;
end;

procedure TSetupTelescope.ButtonEvaluerClick(Sender: TObject);

var codeura,codeurd: longint;
    vita,vitd : double;

begin
 ButtonUtiliser.enabled := true;
 codeura := strtoint(EditResolAlpha.text)*25600;
 codeuralpha := codeura;
 codeurd := strtoint(EditResolDelta.text)*25600;
 codeurdelta := codeurd;
 LabelResolAlpha.caption := 'Rsolution codeur = '+inttostr(codeura) + ' uPas/tour';
 LabelResolDelta.caption := 'Rsolution codeur = '+inttostr(codeurd) + ' uPas/tour';
 vita := codeura/86164.101;
 vit_a_guide := vita;
 vitd := codeurd/86164.101;
 vit_d_guide := 0;
 vit_a_cor_p := 1.25*vita;
 vit_a_cor_m := 0.8*vita;
 vit_d_cor_p := 0.37*vitd;
 vit_d_cor_m := 0.37*vitd;
 vit_a_rap := codeura/180;
 vit_d_rap := codeurd/180;
 vit_a_lent := codeura/3600;
 vit_d_lent := codeurd/3600;
 LabelVitSid.caption := 'Vit. Sidrale = ' + floattostrf(vit_a_guide,ffFixed,6,6) + ' uPas/sec =>' +floattostrf(vit_a_guide*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 Label2VitCorrAlpha.caption := 'Vit. Correction = ' + floattostrf(vit_a_cor_p,ffFixed,6,3) + ' uPas/sec=>' +floattostrf(vit_a_cor_p*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 LabelVitPointLentAlpha.caption := 'Vit. Pointage Lente  = ' + floattostrf(codeura/3600,ffFixed,6,1) + ' uPas/sec => 0,1/sec';
 LabelVitPointRapideAlpha.caption := 'Vit. Pointage Rapide  = ' + floattostrf(codeura/180,ffFixed,6,1) + ' uPas/sec => 2/sec';
 LabelVitGuidage.caption := 'Vit. Guidage = 0 uPas/sec => 0 sec d''arc/sec';
 Label2VitCorrDelta.caption := 'Vit. Correction = ' + floattostrf(vit_d_cor_p,ffFixed,6,3)+ ' uPas/sec =>' +floattostrf(vit_d_cor_p*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 LabelVitPointLentDelta.caption := 'Vit. Pointage Lente  = ' + floattostrf(codeurd/3600,ffFixed,6,1) + ' uPas/sec => 0,1/sec';
 LabelVitPointRapideDelta.caption := 'Vit. Pointage Rapide  = ' + floattostrf(codeurd/180,ffFixed,6,1) + ' uPas/sec => 2/sec';
end;

procedure TSetupTelescope.ButtonActuelClick(Sender: TObject);

var codeura,codeurd: longint;

begin
 ButtonUtiliser.enabled := false;
 codeura := strtoint(Edit_Resol_AD.text);
 codeurd := strtoint(Edit_Resol_DEC.text);
 LabelResolAlpha.caption := 'Rsolution codeur = '+inttostr(codeura) + ' uPas/tour';
 LabelResolDelta.caption := 'Rsolution codeur = '+inttostr(codeurd) + ' uPas/tour';
 LabelVitSid.caption := 'Vit. Sidrale = ' + floattostrf(strtofloat(Edit_V_Guidage_AD.text),ffFixed,6,6) + ' uPas/sec =>' +floattostrf(strtofloat(Edit_V_Guidage_AD.text)*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 Label2VitCorrAlpha.caption := 'Vit. Correction = ' + floattostrf(strtofloat(Edit_V_Corr_P_AD.text),ffFixed,6,3) + ' uPas/sec =>' +floattostrf(strtofloat(Edit_V_Corr_P_AD.text)*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 LabelVitPointLentAlpha.caption := 'Vit. Pointage Lente  = ' + floattostrf(strtofloat(Edit_V_Point_L_AD.text),ffFixed,6,1) + ' uPas/sec => '+floattostrf(strtofloat(Edit_V_Point_L_AD.text)*360/codeura,ffFixed,6,1)+'/sec';
 LabelVitPointRapideAlpha.caption := 'Vit. Pointage Rapide  = ' + floattostrf(strtofloat(Edit_V_Point_R_AD.text),ffFixed,6,1) + ' uPas/sec => '+floattostrf(strtofloat(Edit_V_Point_R_AD.text)*360/codeura,ffFixed,6,1)+'/sec';
 LabelVitGuidage.caption := 'Vit. Guidage = ' + floattostrf(strtofloat(Edit_V_Guidage_DEC.text),ffFixed,6,6) + ' uPas/sec =>' +floattostrf(strtofloat(Edit_V_Guidage_DEC.text)*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 Label2VitCorrDelta.caption := 'Vit. Correction = ' + floattostrf(strtofloat(Edit_V_Corr_P_DEC.text),ffFixed,6,3) + ' uPas/sec =>' +floattostrf(strtofloat(Edit_V_Corr_P_DEC.text)*1296000/codeura,ffFixed,6,1)+' sec d''arc/sec';
 LabelVitPointLentDelta.caption := 'Vit. Pointage Lente  = ' + floattostrf(strtofloat(Edit_V_Point_L_DEC.text),ffFixed,6,1) + ' uPas/sec => '+floattostrf(strtofloat(Edit_V_Point_L_DEC.text)*360/codeurd,ffFixed,6,1)+'/sec';
 LabelVitPointRapideDelta.caption := 'Vit. Pointage Rapide  = ' + floattostrf(strtofloat(Edit_V_Point_R_DEC.text),ffFixed,6,1) + ' uPas/sec => '+floattostrf(strtofloat(Edit_V_Point_R_DEC.text)*360/codeurd,ffFixed,6,1)+'/sec';
end;

procedure TSetupTelescope.ButtonUtiliserClick(Sender: TObject);

begin
 Edit_Resol_AD.text:=inttostr(codeuralpha);
 Edit_Resol_DEC.text:=inttostr(codeurdelta);
 Edit_V_Guidage_AD.text := floattostrf(vit_a_guide,ffFixed,6,6);
 Edit_V_Guidage_DEC.text := floattostrf(vit_d_guide,ffFixed,6,6);
 Edit_V_Corr_P_AD.text := floattostrf(vit_a_cor_p,ffFixed,6,3);
 Edit_V_Corr_P_DEC.text := floattostrf(vit_d_cor_p,ffFixed,6,3);
 Edit_V_Corr_M_AD.text := floattostrf(vit_a_cor_m,ffFixed,6,3);
 Edit_V_Corr_M_DEC.text := floattostrf(vit_d_cor_m,ffFixed,6,3);
 Edit_V_Point_L_AD.text := floattostrf(vit_a_lent,ffFixed,6,1);
 Edit_V_Point_L_DEC.text := floattostrf(vit_d_lent,ffFixed,6,1);
 Edit_V_Point_R_AD.text := floattostrf(vit_a_rap,ffFixed,6,1);
 Edit_V_Point_R_DEC.text := floattostrf(vit_d_rap,ffFixed,6,1);
 //ComboBox_Accel_AD.ItemIndex := 0;
 //ComboBox_Accel_DEC.ItemIndex := 0;
end;

procedure TSetupTelescope.FOCUS_M(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
    astring,receivestring: ShortString;

begin
 //Vrification des ports COM
 while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if Err_COM then
     begin
      FlushFileBuffers(hCom);
      if deviceready(1) = 1 then
      begin
       astring := 'g'+chr(0)+chr(0)+chr(0)+chr(0);
       receivestring := sendcommand(astring,0,1);
      end;
     end;
     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !

   finally
     CloseHandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

procedure TSetupTelescope.FOCUS_P(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
    astring,receivestring: ShortString;

begin
 //Vrification des ports COM
 while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if Err_COM then
     begin
      FlushFileBuffers(hCom);
      if deviceready(1) = 1 then
      begin
       astring := 'f'+chr(0)+chr(0)+chr(0)+chr(0);
       receivestring := sendcommand(astring,0,1);
      end;
     end;
     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !

   finally
     CloseHandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

procedure TSetupTelescope.FOCUS_STOP(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
    astring,receivestring: ShortString;

begin
 //Vrification des ports COM
 while not AccesComAllowance(NumCOM) do;
  AccesCom(NumCOM);
 try
   Open_Cod_Eng(Err_COM);  // Ouvrir le port COM
   try
     if Err_COM then
     begin
      FlushFileBuffers(hCom);
      if deviceready(1) = 1 then
      begin
       astring := 'h'+chr(0)+chr(0)+chr(0)+chr(0);
       receivestring := sendcommand(astring,0,1);
      end;
     end;
     // Il n'y a pas de rponse donc ce n'est pas la peine de lire le Buffer !

   finally
     CloseHandle(hCom);
   end;
 finally
   AccesCom(NumCOM);
 end;
end;

end.
